<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefundTransactionArrayType StructType
 * Meta informations extracted from the WSDL
 * - documentation: This type is deprecated.
 * @subpackage Structs
 */
class RefundTransactionArrayType extends AbstractStructBase
{
    /**
     * The RefundTransaction
     * Meta informations extracted from the WSDL
     * - documentation: This field is deprecated.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RefundTransactionType[]
     */
    public $RefundTransaction;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for RefundTransactionArrayType
     * @uses RefundTransactionArrayType::setRefundTransaction()
     * @uses RefundTransactionArrayType::setAny()
     * @param \StructType\RefundTransactionType[] $refundTransaction
     * @param \DOMDocument $any
     */
    public function __construct(array $refundTransaction = array(), \DOMDocument $any = null)
    {
        $this
            ->setRefundTransaction($refundTransaction)
            ->setAny($any);
    }
    /**
     * Get RefundTransaction value
     * @return \StructType\RefundTransactionType[]|null
     */
    public function getRefundTransaction()
    {
        return $this->RefundTransaction;
    }
    /**
     * Set RefundTransaction value
     * @throws \InvalidArgumentException
     * @param \StructType\RefundTransactionType[] $refundTransaction
     * @return \StructType\RefundTransactionArrayType
     */
    public function setRefundTransaction(array $refundTransaction = array())
    {
        foreach ($refundTransaction as $refundTransactionArrayTypeRefundTransactionItem) {
            // validation for constraint: itemType
            if (!$refundTransactionArrayTypeRefundTransactionItem instanceof \StructType\RefundTransactionType) {
                throw new \InvalidArgumentException(sprintf('The RefundTransaction property can only contain items of \StructType\RefundTransactionType, "%s" given', is_object($refundTransactionArrayTypeRefundTransactionItem) ? get_class($refundTransactionArrayTypeRefundTransactionItem) : gettype($refundTransactionArrayTypeRefundTransactionItem)), __LINE__);
            }
        }
        $this->RefundTransaction = $refundTransaction;
        return $this;
    }
    /**
     * Add item to RefundTransaction value
     * @throws \InvalidArgumentException
     * @param \StructType\RefundTransactionType $item
     * @return \StructType\RefundTransactionArrayType
     */
    public function addToRefundTransaction(\StructType\RefundTransactionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RefundTransactionType) {
            throw new \InvalidArgumentException(sprintf('The RefundTransaction property can only contain items of \StructType\RefundTransactionType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RefundTransaction[] = $item;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \StructType\RefundTransactionArrayType::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \StructType\RefundTransactionArrayType
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RefundTransactionArrayType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
